config/routes.rb
Rails.application.routes.draw do
  resources :todos
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/greetings_logger.rb
class GreetingsLogger
  def self.call
    puts 'Congratulations with completed task!'
  end
end

app/models/todo.rb
class Todo < ApplicationRecord
  validates_presence_of :title, :due_date

  scope :active, -> { where(status: false) }
  scope :completed, -> { where(status: true) }

  def can_destroy?
    !overdue?
  end

  def complete
    self.status = true
    GreetingsLogger.call
  end

  def activate
    self.status = false
  end

  private

  def overdue?
    due_date < Date.today
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/todos_controller.rb
class TodosController < ApplicationController
  before_action :set_todo, only: %i[show edit update destroy]

  # GET /todos
  # GET /todos.json
  def index
    @todos = Todo.order(due_date: :asc)
  end

  # GET /todos/1
  # GET /todos/1.json
  def show; end

  # GET /todos/new
  def new
    @todo = Todo.new
  end

  # GET /todos/1/edit
  def edit; end

  # POST /todos
  # POST /todos.json
  def create
    @todo = Todo.new(todo_params)

    respond_to do |format|
      if @todo.save
        format.html { redirect_to @todo, notice: 'Todo was successfully created.' }
        format.json { render :show, status: :created, location: @todo }
      else
        format.html { render :new }
        format.json { render json: @todo.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /todos/1
  # PATCH/PUT /todos/1.json
  def update
    respond_to do |format|
      if @todo.update(todo_params)
        format.html { redirect_to @todo, notice: 'Todo was successfully updated.' }
        format.json { render :show, status: :ok, location: @todo }
      else
        format.html { render :edit }
        format.json { render json: @todo.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /todos/1
  # DELETE /todos/1.json
  def destroy
    @todo.destroy
    respond_to do |format|
      format.html { redirect_to todos_url, notice: 'Todo was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_todo
    @todo = Todo.find(params[:id])
  end

  # Only allow a list of trusted parameters through.
  def todo_params
    params.require(:todo).permit(:title, :description, :status, :due_date)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>RailsTestingHomework</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/todos/_form.html.erb
<%= form_with(model: todo, local: true) do |form| %>
  <% if todo.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(todo.errors.count, "error") %> prohibited this todo from being saved:</h2>

      <ul>
      <% todo.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= form.label :title %>
    <%= form.text_field :title %>
  </div>

  <div class="field">
    <%= form.label :description %>
    <%= form.text_field :description %>
  </div>

  <div class="field">
    <%= form.label :status %>
    <%= form.check_box :status %>
  </div>

  <div class="field">
    <%= form.label :due_date %>
    <%= form.datetime_select :due_date %>
  </div>

  <div class="actions">
    <%= form.submit %>
  </div>
<% end %>

app/views/todos/edit.html.erb
<h1>Editing Todo</h1>

<%= render 'form', todo: @todo %>

<%= link_to 'Show', @todo %> |
<%= link_to 'Back', todos_path %>

app/views/todos/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Todos</h1>

<table>
  <thead>
    <tr>
      <th>Title</th>
      <th>Description</th>
      <th>Status</th>
      <th>Due date</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @todos.each do |todo| %>
      <tr>
        <td><%= todo.title %></td>
        <td><%= todo.description %></td>
        <td><%= todo.status %></td>
        <td><%= todo.due_date %></td>
        <td><%= link_to 'Show', todo %></td>
        <td><%= link_to 'Edit', edit_todo_path(todo) %></td>
        <td><%= link_to 'Destroy', todo, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Todo', new_todo_path %>

app/views/todos/new.html.erb
<h1>New Todo</h1>

<%= render 'form', todo: @todo %>

<%= link_to 'Back', todos_path %>

app/views/todos/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Title:</strong>
  <%= @todo.title %>
</p>

<p>
  <strong>Description:</strong>
  <%= @todo.description %>
</p>

<p>
  <strong>Status:</strong>
  <%= @todo.status %>
</p>

<p>
  <strong>Due date:</strong>
  <%= @todo.due_date %>
</p>

<%= link_to 'Edit', edit_todo_path(@todo) %> |
<%= link_to 'Back', todos_path %>